/* This is a quick hack of tydopad to check keymap for 
 * iGo/ThinkOutside Stowaway 4-row keyboard
 * http://www.thinkoutside.com/products/elerbye/stowawayir_product.html
 * pm me at futaris at forums.ps2dev.org
 */

#include <pspkernel.h> 
#include <pspdebug.h> 
#include <pspdisplay.h> 
#include <pspctrl.h> 
#include <pspsircs.h> 
#include <stdlib.h> 
#include <string.h>
#include <psprtc.h>
#include <time.h>  
 
PSP_MODULE_INFO("TyDoPad beta", 0, 1, 1); 
 
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU); 

#define printf   pspDebugScreenPrintf 
 
int exit_callback(void) 
{ 
   sceKernelExitGame(); 

   return 0; 
} 
 
void CallbackThread(void *arg) 
{ 
   int cbid; 

   cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL); 
   sceKernelRegisterExitCallback(cbid); 

   sceKernelSleepThreadCB(); 
} 
 
int SetupCallbacks(void) 
{ 
   int thid = 0; 

   thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0); 
   if(thid >= 0) 
   { 
      sceKernelStartThread(thid, 0, 0); 
   } 

   return thid; 
} 

unsigned char getIrPress(int fd, int textfd, int *shift)
{
  unsigned char p, key = 0;
  int len = 0;
  int i = 0;
  int readKeys = 0;
  
  SceCtrlData pad; 
  sceCtrlReadBufferPositive(&pad, 1);
  sceDisplayWaitVblankStart();
  
  if (pad.Buttons & PSP_CTRL_START) 
    {  
       key = '\n';
       sceIoWrite(textfd, &key, 1);
       sceIoWrite(textfd, &key, 1);
       sceIoWrite(textfd, &key, 1);
       sceIoClose(textfd);
    }
  
  while (i < 6)
    {
      len = sceIoRead(fd, &p, 1);
      if (len == 1)
      {
        // printf("%3d ", p);
        i++;
      }
      if (i == 3)
        key = p;
        
      readKeys++;
      if (readKeys > 40)
      {
        sceCtrlReadBufferPositive(&pad, 1);
        if (pad.Buttons & PSP_CTRL_START) 
        {  
           return 200; // save
           /* 
           */
        }
        readKeys = 0;
      }
      
    }
  
if (*shift == 0)
  switch (key) {
    case 0x58: *shift = 1; return 0; // Shift-L
    case 0x09: return 'q';
    case 0x0a: return 'w';
    case 0x0b: return 'e';
    case 0x11: return 'a';
    case 0x03: return 'z';
    case 0x08: return 200; // cmd
    case 0x1b: return 0; // tab
    case 0x0c: return 'r';
    case 0x12: return 's';
    case 0x10: return 'x';
    case 0x18: *shift = 1; return 0; // caps lock?
    case 0x1a: return 0; // ctrl
    case 0x0d: return 't';
    case 0x13: return 'd';
    case 0x2c: return 'c';
    case 0x2d: return 'v';
    case 0x2e: return 'b';
    case 0x23: return 0; // alt
    case 0x14: return 'f';
    case 0x17: return ' '; // space
    case 0x16: return 'h';
    case 0x15: return 'g';
    case 0x0e: return 'y';
    case 0x22: return 0; // Fn-L
    case 0x37: return ' '; // space
    case 0x51: return 0; // left
    case 0x2f: return 'n';
    case 0x44: return 'j';
    case 0x24: return 0; // Fn-R
    case 0x52: return 0; // down
    case 0x48: return '/';
    case 0x4c: return 'm';
    case 0x45: return 'k';
    case 0x3c: return 'u';
    case 0x53: return 0; // right
    case 0x4d: return ',';
    case 0x47: return ';';
    case 0x46: return 'l';
    case 0x3d: return 'i';
    case 0x50: return 0; // del
    case 0x4e: return '.';
    case 0x56: return '`';
    case 0x38: return '-';
    case 0x3e: return 'o';
    case 0x3a: return '/';
    case 0x57: return 0; // enter
    case 0x32: return 8; // backspace
    case 0x39: return '=';
    case 0x3f: return 'p';
    case 0x59: *shift == 1; return 0; // Shift-R
    default: return 0;
  }
  
if (*shift == 1)
  switch (key) {
    case 0x58: *shift = 0; return 0; // Shift-L
    case 0x09: return 'Q';
    case 0x0a: return 'W';
    case 0x0b: return 'E';
    case 0x11: return 'A';
    case 0x03: return 'Z';
    case 0x08: return 200; // cmd
    case 0x1b: return 0; // tab
    case 0x0c: return 'R';
    case 0x12: return 'S';
    case 0x10: return 'X';
    case 0x18: *shift = 0; // caps lock?
    case 0x1a: return 0; // ctrl
    case 0x0d: return 'T';
    case 0x13: return 'D';
    case 0x2c: return 'C';
    case 0x2d: return 'V';
    case 0x2e: return 'B';
    case 0x23: return 0; // alt
    case 0x14: return 'F';
    case 0x17: return ' '; // space
    case 0x16: return 'H';
    case 0x15: return 'G';
    case 0x0e: return 'Y';
    case 0x22: return 0; // Fn-L
    case 0x37: return ' '; // space
    case 0x51: return 0; // left
    case 0x2f: return 'N';
    case 0x44: return 'J';
    case 0x24: return 0; // Fn-R
    case 0x52: return 0; // down
    case 0x48: return '/';
    case 0x4c: return 'M';
    case 0x45: return 'K';
    case 0x3c: return 'U';
    case 0x53: return 0; // right
    case 0x4d: return '<';
    case 0x47: return ':';
    case 0x46: return 'L';
    case 0x3d: return 'I';
    case 0x50: return 0; // del
    case 0x4e: return '>';
    case 0x56: return '~';
    case 0x38: return '_';
    case 0x3e: return 'O';
    case 0x3a: return '?';
    case 0x57: return 0; // enter
    case 0x32: return 8; // backspace
    case 0x39: return '+';
    case 0x3f: return 'P';
    case 0x59: *shift == 0; return 0; // Shift-R
    default: return 0;
  }
  
  
  return 0;
}


int main(void) 
{ 
   // char buffer[10]; 
   // unsigned char data;
   // SceCtrlData pad; 
   // u32 buttonsold = 0; 
   int x = 0, y = 2;
   int i = 0, t = 0;
   unsigned char c;
   int len;
   unsigned char text[4096];
   // text[1023] = '\0';
   int textfd;
   char header[100];
   pspTime time; 
	 sceRtcGetCurrentClockLocalTime(&time);

   SetupCallbacks(); 
   pspDebugScreenInit(); 

   sceCtrlSetSamplingCycle(0); 
   sceCtrlSetSamplingMode(PSP_CTRL_MODE_DIGITAL); 

   printf(" TyDoPad v0.01 (iGo/ThinkOutside Stowaway Keyboard) by futaris\n"); 
   printf("---------------------------------------------------------------\n"); 

   int fd = sceIoOpen("irda0:", PSP_O_RDWR, 0); 
   int shift = 0;
   
   textfd = sceIoOpen("ms0:/TyDoPad_notes.txt", PSP_O_WRONLY | PSP_O_CREAT | PSP_O_APPEND, 0777);
	 if (textfd < 0) {
		printf("Cannot open file ms0:/TyDoPad_notes.txt\n");
		return -1;
	 }
 
	 
	 snprintf(header, 95, "\r\n\r\n======================\r\n     TyDoPad note\r\n   %04d %02d-%02d %02d:%02d\r\n======================\r\n\r\n", time.year, time.month, time.day, time.hour, time.minutes);
	 while (header[i] != '\0')
	   {
        c = header[i];
        sceIoWrite(textfd, &c, 1);
        i++;
     }
   
   pspDebugScreenSetXY(x, y);

  while (1) 
  {
    int c = getIrPress(fd, textfd, &shift);
    if (c)
    { 
      
      if (x > 65) // 65
        { 
          printf("\n");
          x = 0;
          y++;
          // pspDebugScreenSetXY(x, y);
        }
      if (y > 32)   // 32
        {
          x = 66;
          y = 1;
          pspDebugScreenSetXY(x, y);
          printf("\n");
          y = 2;
          x = 0;
          // pspDebugScreenSetXY(x, y);
        }
      
      
      if (c == 200) // save
      {
        int i = 0;
        unsigned char c;
        printf("\n\nSaving...  ");
        
        text[t] = '\0';
        while (text[i] != '\0')
        {
          c = text[i];
          sceIoWrite(textfd, &c, 1);
          i++;
        }
        
        unsigned char key1 = '\r'; unsigned char key2 = '\n'; 
        sceIoWrite(textfd, &key1, 1); sceIoWrite(textfd, &key2, 1); sceIoWrite(textfd, &key1, 1); sceIoWrite(textfd, &key2, 1); sceIoWrite(textfd, &key1, 1); sceIoWrite(textfd, &key2, 1);  
        sceIoClose(textfd);
        printf("Saved. Now you can exit TyDoPad.");
      } else if (c == 8)
      {
        if ((t > 0) && (x > 0))
        {
          t--;
          x--;
          pspDebugScreenSetXY(x, y);
          printf(" ");
          pspDebugScreenSetXY(x-1, y);
        }
      } else
      {
        if ((t < 4093) && (c != 8))
        { 
          pspDebugScreenSetXY(x, y);
          
          if (c == '\n')
          { 
            x = -1;
            y++;
            text[t] = '\r';
            t++;
          }
          
          printf("%c", c);
          x++;
          pspDebugScreenSetXY(x, y);
          
          
          text[t] = c;
          t++;
          
        } else
        {
          printf("\nMaximum note size exceeded. Please save (START) and exit.");
        }
      }
      
      
    }
      
    sceDisplayWaitVblankStart(); 
  }

   return 0; 
}
